﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Globalization;

namespace ISY.CAD.Noise
{
    public partial class IndustryNoiseForm : Bentley.MicroStation.WinForms.Adapter
    {
        public static NoiseTimeDistributionForm distributionForm;

        public IndustryNoiseForm()
        {
            InitializeComponent();
            comboBoxNoiseSource.SelectedIndex = 0;
            buttonDefineDistribution.Enabled = false;
        }

        private void buttonDefine_Click(object sender, EventArgs e)
        {
            Form specForm = new NoiseSourceSpecForm();
            specForm.Show();
        }

        private void comboBoxType_SelectedIndexChanged(object sender, EventArgs e)
        {
            if ((string)comboBoxNoiseSource.SelectedItem == "User Defined")
                buttonDefine.Enabled = true;
            else
            {
                buttonDefine.Enabled = false;
                NoiseSourceSpecForm.freqSpectra = null;
            }
        }

        public string GetNoiseSource()
        {
            return comboBoxNoiseSource.SelectedItem.ToString();
        }

        public float GetAmount()
        {
            string s = textBoxAmount.Text;
            if (s.Contains(","))
            {
                MessageBox.Show("Error! Use point as decimal separator.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return -1;
            }

            try
            {
                return (float)double.Parse(s, CultureInfo.InvariantCulture);
            }
            catch (Exception ee)
            {
                MessageBox.Show("Error!" + ee.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return -1;
            }
        }

        public string getDistributionType()
        {
            if (radioButtonGeneral.Checked)
                return "General";
            else if (radioButtonWork.Checked)
                return "Work";
            else return "UserDefined";
        }

        public string getGeometry()
        {
            if (radioButtonPoint.Checked)
                return "point";
            else if (radioButtonLine.Checked)
                return "line";
            else if (radioButtonArea.Checked)
                return "area";
            else return "volume";
        }

        private void radioButtonUserDefined_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonUserDefined.Checked)
            {
                NoiseTimeDistributionForm.distribution = NoiseTimeDistributionForm.defaultUsehoursDistribution;
                buttonDefineDistribution.Enabled = true;
                this.textBoxAmount.Text = NoiseTimeDistributionForm.defaultUsehoursDistribution[9].ToString();
            }
            else
                buttonDefineDistribution.Enabled = false;
        }

        private void radioButtonWork_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonUserDefined.Checked)
                buttonDefineDistribution.Enabled = true;
            else
                buttonDefineDistribution.Enabled = false;
        }

        private void radioButtonGeneral_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonUserDefined.Checked)
                buttonDefineDistribution.Enabled = true;
            else
                buttonDefineDistribution.Enabled = false;
        }

        private void buttonDefineDistribution_Click(object sender, EventArgs e)
        {
            NoiseTimeDistributionForm.amountunit = "usehours";
            distributionForm = new NoiseTimeDistributionForm();
            distributionForm.Show();
        }

    }
}
