﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Bentley.MicroStation.WinForms;
//using ISY.CAD.Settings;
using BCOM = Bentley.Interop.MicroStationDGN;
using BM = Bentley.MicroStation;
using BMI = Bentley.MicroStation.InteropServices;
using System.Globalization;

namespace ISY.CAD.Noise
{
    public partial class MoundForm : Bentley.MicroStation.WinForms.Adapter
    {
        public MoundForm()
        {
            InitializeComponent();
            textBoxLeftHeight.Enabled = false;
            textBoxRightHeight.Enabled = false;
            textBoxWidthBottom.Enabled = false;
            textBoxWidthTop.Enabled = false;
            textBoxHeight.Enabled = true;
        }

        public float GetHeight()
        {
            return float.Parse(textBoxHeight.Text, CultureInfo.InvariantCulture);
        }

        public float GetLeftHeight()
        {
            return float.Parse(textBoxLeftHeight.Text, CultureInfo.InvariantCulture);
        }

        public float GetRightHeight()
        {
            return float.Parse(textBoxRightHeight.Text, CultureInfo.InvariantCulture);
        }

        public float GetTopWidth()
        {
            return float.Parse(textBoxWidthTop.Text, CultureInfo.InvariantCulture);
        }

        public float GetBottomWidth()
        {
            return float.Parse(textBoxWidthBottom.Text, CultureInfo.InvariantCulture);
        }

        public string GetType()
        {
            if (radioButtonScreen.Checked)
                return "screen";
            else if (radioButtonMound.Checked)
                return "mound";
            else if (radioButtonWall.Checked)
                return "wall";
            else
                MessageBox.Show("Error: Type has not been selected!");
            return "";
        }


        private void radioButtonScreen_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonScreen.Checked == true && radioButtonMound.Checked)
                radioButtonMound.Checked = false;
            if (radioButtonScreen.Checked == true && radioButtonWall.Checked)
                radioButtonWall.Checked = false;
            textBoxLeftHeight.Enabled = false;
            textBoxRightHeight.Enabled = false;
            textBoxWidthBottom.Enabled = false;
            textBoxWidthTop.Enabled = false;
            textBoxHeight.Enabled = true;
        }

        private void radioButtonMound_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonMound.Checked == true && radioButtonScreen.Checked)
                radioButtonScreen.Checked = false;
            if (radioButtonMound.Checked == true && radioButtonWall.Checked)
                radioButtonWall.Checked = false;
            textBoxHeight.Enabled = false;
            textBoxLeftHeight.Enabled = true;
            textBoxRightHeight.Enabled = true;
            textBoxWidthBottom.Enabled = true;
            textBoxWidthTop.Enabled = true;
        }

        private void radioButtonWall_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonWall.Checked == true && radioButtonMound.Checked)
                radioButtonMound.Checked = false;
            if (radioButtonWall.Checked == true && radioButtonScreen.Checked)
                radioButtonScreen.Checked = false;
            textBoxHeight.Enabled = false;
            textBoxWidthBottom.Enabled = false;
            textBoxLeftHeight.Enabled = true;
            textBoxRightHeight.Enabled = true;
            textBoxWidthTop.Enabled = true;
        }

    }
}
