﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Globalization;

namespace ISY.CAD.Noise
{
    public partial class NoiseSourceSpecForm : Form
    {
        public static double[] freqSpectra;
        public static double[] defaultSpectra = { 
               100.3, 100.3, 100.3, 
               100.3, 100.3, 100.3, 
               100.3, 100.3, 100.3};

        public NoiseSourceSpecForm()
        {
            InitializeComponent();
            textBox31Hz.Text = defaultSpectra[0].ToString();
            textBox63Hz.Text = defaultSpectra[1].ToString();
            textBox125Hz.Text = defaultSpectra[2].ToString();
            textBox250Hz.Text = defaultSpectra[3].ToString();
            textBox500Hz.Text = defaultSpectra[4].ToString();
            textBox1kHz.Text = defaultSpectra[5].ToString();
            textBox2kHz.Text = defaultSpectra[6].ToString();
            textBox4kHz.Text = defaultSpectra[7].ToString();
            textBox8kHz.Text = defaultSpectra[8].ToString();
        }
        private void buttonDone_Click(object sender, EventArgs e)
        {
            string[] textBoxes = new string[9];
            textBoxes[0] = textBox31Hz.Text;
            textBoxes[1] = textBox63Hz.Text;
            textBoxes[2] = textBox125Hz.Text;
            textBoxes[3] = textBox250Hz.Text;
            textBoxes[4] = textBox500Hz.Text;
            textBoxes[5] = textBox1kHz.Text;
            textBoxes[6] = textBox2kHz.Text;
            textBoxes[7] = textBox4kHz.Text;
            textBoxes[8] = textBox8kHz.Text;
            //defaultSpectra = textBoxes;

            foreach (string s in textBoxes)
                if (s.Contains(","))
                {
                    MessageBox.Show("Error! Use point as decimal separator.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    break;
                }
            for (int i = 0; i< 9; i++) 
                if (textBoxes[i].Trim() == string.Empty)
                    textBoxes[i] = "-200"; // a large negative value, NEVER 0
            
                freqSpectra = new double[9];
                try
                {
                    for (int i = 0; i< 9; i++)
                        freqSpectra[i] = double.Parse(textBoxes[i], CultureInfo.InvariantCulture);
                }
                catch (Exception ee)
                {
                    MessageBox.Show("Error!" + ee.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }

                defaultSpectra = freqSpectra;
                this.Close();
            
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

    }
}
