﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Globalization;

namespace ISY.CAD.Noise
{
    public partial class NoiseTimeDistributionForm : Form
    {
        public static string amountunit;

        public static double[] distribution;
        public static double[] defaultAadtDistribution = { 
               2000, 250, 250, 
               2000, 250, 250, 
               2000, 250, 250, 
               2500};
        public static double[] defaultUsehoursDistribution = { 
               8.0, 0.0, 0.0, 
               0.0, 0.0, 0.0, 
               0.0, 0.0, 0.0, 
               8.0};

        bool isInitializing;

        public NoiseTimeDistributionForm()
        {
            isInitializing = true;
            InitializeComponent();
            if (amountunit == "usehours")
            {
                labelNote.Text = "NOTE: The summarized values for a day \r\nhas to be equal to or less than the \r\npre" +
    "vious given amount.";
                changeLabelNumberOf.Text = "Number of hours in use:";

                textBoxDaytime1.Text = defaultUsehoursDistribution[0].ToString();
                textBoxEvening1.Text = defaultUsehoursDistribution[1].ToString();
                textBoxNighttime1.Text = defaultUsehoursDistribution[2].ToString();
                textBoxDaytime2.Text = defaultUsehoursDistribution[3].ToString();
                textBoxEvening2.Text = defaultUsehoursDistribution[4].ToString();
                textBoxNighttime2.Text = defaultUsehoursDistribution[5].ToString();
                textBoxDaytime3.Text = defaultUsehoursDistribution[6].ToString();
                textBoxEvening3.Text = defaultUsehoursDistribution[7].ToString();
                textBoxNighttime3.Text = defaultUsehoursDistribution[8].ToString();
                textBoxAmount.Text = defaultUsehoursDistribution[9].ToString();
            }
            else if (amountunit == "aadt")
            {
                labelNote.Text = "NOTE: The summarized values for a day \r\nhas to be equal to or less than the \r\npre" +
    "vious given aadt.";
                changeLabelNumberOf.Text = "Number of vehicles:";

                textBoxDaytime1.Text = defaultAadtDistribution[0].ToString();
                textBoxEvening1.Text = defaultAadtDistribution[1].ToString();
                textBoxNighttime1.Text = defaultAadtDistribution[2].ToString();
                textBoxDaytime2.Text = defaultAadtDistribution[3].ToString();
                textBoxEvening2.Text = defaultAadtDistribution[4].ToString();
                textBoxNighttime2.Text = defaultAadtDistribution[5].ToString();
                textBoxDaytime3.Text = defaultAadtDistribution[6].ToString();
                textBoxEvening3.Text = defaultAadtDistribution[7].ToString();
                textBoxNighttime3.Text = defaultAadtDistribution[8].ToString();
                textBoxAmount.Text = defaultAadtDistribution[9].ToString();
            }

            isInitializing = false;
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void buttonDone_Click(object sender, EventArgs e)
        {
            string[] textBoxes = new string[9];
            textBoxes[0] = textBoxDaytime1.Text;
            textBoxes[1] = textBoxEvening1.Text;
            textBoxes[2] = textBoxNighttime1.Text;
            textBoxes[3] = textBoxDaytime2.Text;
            textBoxes[4] = textBoxEvening2.Text;
            textBoxes[5] = textBoxNighttime2.Text;
            textBoxes[6] = textBoxDaytime3.Text;
            textBoxes[7] = textBoxEvening3.Text;
            textBoxes[8] = textBoxNighttime3.Text;

            foreach (string s in textBoxes)
                if (s.Contains(","))
                {
                    MessageBox.Show("Error! Use point as decimal separator.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    break;
                }
            for (int i = 0; i < 9; i++)
                if (textBoxes[i].Trim() == string.Empty)
                    textBoxes[i] = "-200"; // a large negative value, NEVER 0

            distribution = new double[10];
            try
            {
                for (int i = 0; i < 9; i++)
                    distribution[i] = double.Parse(textBoxes[i], CultureInfo.InvariantCulture);
            }
            catch (Exception ee)
            {
                MessageBox.Show("Error!" + ee.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            
            distribution[9] = distribution[0] + distribution[1] + distribution[2];

            if (amountunit == "aadt")
            {
                defaultAadtDistribution = distribution;
                MessageBox.Show("New AADT have to be: "+distribution[9]);
            }
            else if (amountunit == "usehours")
            {
                defaultUsehoursDistribution = distribution;
                MessageBox.Show("New Amount have to be: " + distribution[9]);
            }
            this.Close();

           
        }

        private void textBoxDaytime1_TextChanged(object sender, EventArgs e)
        {
            if (!isInitializing)
                try
                {
                textBoxAmount.Text = (double.Parse(textBoxDaytime1.Text, CultureInfo.InvariantCulture) +
                    double.Parse(textBoxEvening1.Text, CultureInfo.InvariantCulture) +
                    double.Parse(textBoxNighttime1.Text, CultureInfo.InvariantCulture)).ToString(); }
                catch
                {
                    if (textBoxDaytime1.Text.Trim() == string.Empty)
                        textBoxAmount.Text = (double.Parse(textBoxEvening1.Text, CultureInfo.InvariantCulture) +
                        double.Parse(textBoxNighttime1.Text, CultureInfo.InvariantCulture)).ToString();
                }
        }

        private void textBoxEvening1_TextChanged(object sender, EventArgs e)
       {
            if (!isInitializing)
                try
                {
                    textBoxAmount.Text = (double.Parse(textBoxDaytime1.Text, CultureInfo.InvariantCulture) +
                        double.Parse(textBoxEvening1.Text, CultureInfo.InvariantCulture) +
                        double.Parse(textBoxNighttime1.Text, CultureInfo.InvariantCulture)).ToString();
                }
                catch
                {
                    if (textBoxEvening1.Text.Trim() == string.Empty)
                        textBoxAmount.Text = (double.Parse(textBoxDaytime1.Text, CultureInfo.InvariantCulture) +
                        double.Parse(textBoxNighttime1.Text, CultureInfo.InvariantCulture)).ToString();
                }
        }

        private void textBoxNighttime1_TextChanged(object sender, EventArgs e)
        {
            if (!isInitializing)
                try
                {
                textBoxAmount.Text = (double.Parse(textBoxDaytime1.Text, CultureInfo.InvariantCulture) +
                    double.Parse(textBoxEvening1.Text, CultureInfo.InvariantCulture) +
                    double.Parse(textBoxNighttime1.Text, CultureInfo.InvariantCulture)).ToString();
                }
                catch
                {
                    if (textBoxNighttime1.Text.Trim() == string.Empty)
                        textBoxAmount.Text = (double.Parse(textBoxDaytime1.Text, CultureInfo.InvariantCulture) +
                        double.Parse(textBoxEvening1.Text, CultureInfo.InvariantCulture)).ToString();
                }
        }
    }
}
